{% extends "base.html" %}
{% block overview_table %}
    <table class="table address-table">
        <tr>
            <th title="{{ colnames['DBNetArea']['name'].long_title }}">{{ colnames['DBNetArea']['name'].short_title_abs }}</th>
            <td colspan="2">{{ area.print_name }}</td>
        </tr>
        <tr>
            <th title="{{ colnames['DBNetArea']['description'].long_title }}">{{ colnames['DBNetArea']['description'].short_title_abs }}</th>
            <td>{{ area.description }}</td>
            <td>
                <a href="{{ url_for('dnsvs.edit_range_descr', area=area.name, suffix=area.suffix) }}"
                   class="btn btn-outline-primary d-print-none"><i
                        class="fa fa-pencil" aria-hidden="true"></i></a>
            </td>
        </tr>
        <tr>
            <th title="{{ colnames['Facility']['short_name'].long_title }}">{{ colnames['Facility']['short_name'].short_title_abs }}</th>
            <td title="{{ area.facility.name }}" colspan="2">{{ area.facility.short_name }}</td>
        </tr>
        <tr>
            <th title="{{ colnames['Net']['net'].long_title }}">{{ colnames['Net']['net'].short_title_abs }}</th>
            <td colspan="2"><code>{{ area.net.net }}</code></td>
        </tr>
        {% if area.net.net.version == 4 %}
            <tr>
                <th title="{{ colnames['Net']['ip_mask'].long_title }}">{{ colnames['Net']['ip_mask'].short_title_abs }}</th>
                <td colspan="2"><code>{{ area.net.net.netmask }}</code></td>
            </tr>
        {% endif %}
        <tr>
            <th title="{{ colnames['Net']['b0'].long_title }}">{{ colnames['Net']['b0'].short_title_abs }}</th>
            <td colspan="2" data-network-address="{{ area.net.net.network_address }}"><code>{{ area.net.net.network_address }}</code></td>
        </tr>
        {% if area.net.net.version == 4 %}
            <tr>
                <th title="{{ colnames['Net']['b1'].long_title }}">{{ colnames['Net']['b1'].short_title_abs }}</th>
                <td colspan="2" data-max-address="{{ area_max.ip_addr }}" data-min-address="{{ area_min.ip_addr }}" data-broadcast-address="{{ area.net.net.broadcast_address }}"><code>{{ area.net.net.broadcast_address }}</code></td>
            </tr>
        {% endif %}
        <tr>
            <th title="{{ colnames['DBNetArea']['gateway_list'].long_title }}">{{ colnames['DBNetArea']['gateway_list'].short_title_abs }}</th>
            <td colspan="2">
                <ul class="list-unstyled">{% for g in gateways %}
                    <li><code>{{ g }}</code></li>
                {% endfor %}
                </ul>
            </td>
        </tr>
        {% if area.vlan %}
            <tr>
                <th>VLAN</th>
                <td colspan="2" title="{{ area.vlan.ni_name }}">{{ area.vlan.name }} (<a title="VLAN {{ area.vlan.id }} in der NETDOC" href="https://www-net{% if not omdl.OP_ENV_IS_PROD %}-devel{% endif %}.scc.kit.edu/~netadmin/netdoc/user/wrapper.cgi/{{ area.vlan.ni_name }}/{{ area.vlan.id }}/"
                                                                                         target="_blank">{{ area.vlan.id }}</a>)</td>
            </tr>
        {% endif %}
        {% if nat_range %}
            <tr>
                <th>NATVS-Bereich</th>
                <td colspan="2"><a target="_blank" href="https://www-net{% if not omdl.OP_ENV_IS_PROD %}-devel{% endif %}.scc.kit.edu/~netadmin/natvs/user/wrapper.cgi/{{ nat_range.print_name }}/{{ area.print_name }}/">{{ nat_range.print_name }}</a></td>
            </tr>
        {% endif %}
        <tr>
            <th title="{{ colnames['DBNetArea']['owner_list'].long_title}}">{{ colnames['DBNetArea']['owner_list'].short_title_abs }}</th>
            <td>
                <ul class="list-unstyled">
                    {% for m in mgrs %}
                        <li>
                            {% if m.is_locked %}
                                <i class="fa fa-ban text-danger"
                                   aria-hidden="true"></i>
                                <s class="alert-danger">{% endif %}{{ m.first_name }} {{ m.last_name }}
                            ({{ m.login_name }}{% if m.is_scc_itb %}, ITB{% endif %}){% if m.is_locked %}</s>{% endif %}
                            {% if not m.is_locked %}
                                <a href="mailto:{{ m.first_name }} {{ m.last_name }}<{{ m.email }}>?subject=DNSVS: Adressbereich '{{ area.print_name}}' ({{ area.net.net }})"
                                class="d-print-none">
                                    <i
                                            class="fa fa-envelope"
                                            aria-hidden="true"></i>
                                </a>
                            {% endif %}
                        </li>
                    {% endfor %}
                </ul>
            </td>
            <td class="d-print-none">
                {% if mgrs|length > 0 %}
                    <a href="mailto: {% for m in mgrs %}{{ m.first_name }} {{ m.last_name }}<{{ m.email }}>,{% endfor %}?subject=DNSVS: Adressbereich '{{ area.print_name }}' ({{ area.net.net }})"
                       class="btn btn-outline-primary">
                        <i class="fa fa-envelope" aria-hidden="true"></i>
                    </a>
                {% endif %}
                {% if user.is_scc_itb or user.has_permission('dns.rw_range') %}
                    <a href="{{ url_for('dnsvs.edit_mgrs', area=area.name, suffix=area.suffix) }}"
                       class="btn btn-outline-primary"><i
                            class="fa fa-pencil" aria-hidden="true"></i></a></td>
                {% endif %}
        </tr>
        <tr>
            <th title="{{ colnames['DBNetArea']['subdom_list'].long_title}}">{{ colnames['DBNetArea']['subdom_list'].short_title_abs}}</th>
            <td>
                <ul class="list-unstyled">
                    {% for n in ntree %}
                        <li title="{{ n.description }}">{{ n.fqdn }}</li>
                    {% endfor %}
                </ul>
            </td>
            <td class="d-print-none">
                {% if user.is_scc_itb or user.has_permission('dns.rw_range') %}
                    <a href="{{ url_for('dnsvs.edit_range_domains', area=area.name, suffix=area.suffix) }}"
                       class="btn btn-outline-primary"><i
                            class="fa fa-pencil" aria-hidden="true"></i></a>
                {% endif %}
            </td>
        </tr>
        <tr>
            <th>Letzte Änderung</th>
            {% if last_ev %}
            <td>{{ last_ev.timestamp|strftime }} durch {{ last_ev.mgr.first_name }} {{ last_ev.mgr.last_name }}
                ({{ last_ev.mgr.login_name }})</td>
            <td class="d-print-none"><a class="btn btn-outline-primary"
                   href="{{ url_for('dnsvs.area_evlog', area=area.name, suffix=area.suffix) }}">Letzte
                Änderungen</a>
            </td>
                {% else %}
                <td colspan="2"><i>Keine Änderungen vorhanden</i></td>
            {% endif %}
        </tr>
    </table>
{% endblock %}
{% block body %}
    <div class="row d-print-table">
        <div class="col-md-10" role="main">
            <section id="overview">
                <div class="card d-print-table-row">
                    <div class="card-header">Bereich</div>
                    {{ self.overview_table() }}
                </div>
            </section>
            <h2 class="page-header rr-head-anchor" id="recs">DNS Records</h2>
            <div class="net-filter d-print-none">
                <div class="input-group">
                     <div class="input-group-prepend">
                        <span class="input-group-text" id="basic-addon1"><i class="fa fa-filter"
                                                                             aria-hidden="true"></i></span>
                     </div>
                    <input class="search form-control" id="filterbar" placeholder="Filter" autofocus="yes"/>
                </div>
            </div>
            <div id="listReserved">
                <section id="secReserved" class="rr-list-anchor">
                    <div class="card d-print-table-row">
                        <div data-toggle="collapse" data-target="#reserved"
                                                     aria-expanded="true"
                                                     class="card-header mouse-link netsuite-collapse collapsed">
                            Reservierte Adressen
                            <i class="caret fa fa-caret-down pull-right d-print-none"></i></div>
                        <div class="table-responsive collapse d-print-block" id="reserved">
                            <table class="table table-striped address-table">
                                <tr>
                                    <th class="vertical-center">Adresse</th>
                                </tr>
                                <tbody class="list">
                                {% for i in reserved_addrs %}
                                    <td class="rr-data" data-rr="{{ i.ip_addr }}">
                                        <code>{{ i.ip_addr }}</code>
                                    </td>
                                    </tr>
                                {% endfor %}
                                </tbody>
                            </table>
                        </div>
                    </div>
                </section>
            </div>
            {% for r in rr_types if r.name in possible_rr_names or r.name in rrs %}
                <div id="list{{ r.name }}" class="padding-card-sections">
                    <section id="sec{{ r.name }}" class="rr-list-anchor">
                        <div class="card d-print-table-row">
                            <div data-toggle="collapse" data-target="#{{ r.name }}"
                                                         aria-expanded="true"
                                                         class="card-header mouse-link netsuite-collapse collapsed">{{ r.name }}
                                Records
                                <i class="caret pull-right fa fa-caret-down d-print-none"></i></div>
                            <div class="collapse d-print-block" id="{{ r.name }}">
                                <table class="table table-striped fill address-table">
                                    <thead>
                                        <tr data-rrt="{{ r.name }}">
                                            <th class="vertical-center" title="{{ colnames['NTree']['fqdn'].long_title }}"
                                                colspan="2">{{ colnames['NTree']['fqdn'].short_title_abs }} <a class="sort" data-order="asc" data-rectype="{{ r.name }}" data-target="fqdn" href="javascript:void(0)"><i class="fa fa-sort-asc"></i></a></th>
                                            <th class="vertical-center"
                                                title="{{ colnames['NTree']['description'].long_title }}">{{ colnames['NTree']['description'].short_title_abs }} <a class="sort" data-rectype="{{ r.name }}" data-order="" data-target="description" href="javascript:void(0)"><i class="fa fa-sort"></i></a></th>
                                            <th class="vertical-center">Record-Data <a class="sort" data-order="" data-rectype="{{ r.name }}" data-target="rr-data" href="javascript:void(0)"><i class="fa fa-sort"></i></a></th>
                                            <th class="vertical-center d-print-none">Aktionen</th>
                                            <th class="d-print-none">
                                                {% if r.name in possible_rr_names %}
                                                    <a href="{{ url_for('dnsvs.create_rr_data', area=area.name, suffix=area.suffix, type=r.name) }}"
                                                       title="Neuen Record anlegen" class="btn btn-outline-success"><i
                                                            class="fa fa-plus"></i></a>
                                                {% endif %}
                                            </th>
                                        </tr>
                                    </thead>
                                    <tbody class="list card-table">
                                    {% for i in rrs[r.name] %}
                                        <tr data-rrt="{{ r.name }}">
                                            <td class="fqdn vertical-center" title="{{ i['NTree'].dbnt_name }}">
                                                {{ i['NTree'].fqdn }} {% if i['NTree'].is_d %}<span class="badge badge-info">Domain</span>{% endif %}
                                            </td>
                                            <td class="vertical-center">
                                                <div class="btn-group d-print-none">
                                                    <button type="button" class="btn btn-default dropdown-toggle"
                                                            data-toggle="dropdown" aria-haspopup="true"
                                                            aria-expanded="false">
                                                    <span class="fa fa-info-circle"
                                                          aria-hidden="true"></span> <span class="caret"></span>
                                                    </button>
                                                    <div class="dropdown-menu">
                                                        <a class="dropdown-item"
                                                           href="{{ url_for('dnsvs.inspect_fqdn_recs', fqdn=i['NTree'].fqdn) }}">Alle
                                                            Records zu FQDN</a>
                                                        <a class="dropdown-item"
                                                           href="{{ url_for('dnsvs.inspect_fqdn_refs', fqdn=i['NTree'].fqdn) }}">Alle
                                                            Referenzen auf FQDN</a>
                                                    </div>
                                                </div>
                                            </td>
                                            <td class="description vertical-center">
                                                {{ i['NTree'].description }}
                                            </td>
                                            <td class="rr-data" data-rr="{% if 'IPv6Address' in i['rr'].rr_data_target.__class__.__name__ %}{{ i['rr'].rr_data_target.exploded }}{% else %}{{ i['rr'].rr_data }}{% endif %}">
                                                <code title="{{ i['rr'].inttype.name }}">{{ i['rr'].rr_data }}</code>
                                                {% if i['rr'].inttype.is_set %}
                                                    <span class="badge badge-warning" title="Teil eines RR-Sets">Set</span>
                                                {% endif %}
                                                {% if i['rr'].rr_data in reserved_addrs %}
                                                    <span class="badge badge-danger" title="{{ colnames['DNSAddr']['reserved'].long_title }}">Reserviert</span>
                                                {% endif %}
                                                {% if i['rr'].host_is_nws %}
                                                    <a class="badge badge-primary" target="_blank" href=
                                                            "https://www-net{% if not omdl.OP_ENV_IS_PROD %}-devel{% endif %}.scc.kit.edu/~netadmin/natvs/user/wrapper.cgi/{{ nat_range.print_name }}/{{ area.print_name }}/nat_index.html">
                                                        NATVS</a>
                                                {% endif %}
                                            </td>
                                            <td colspan="2" class="d-print-none">
                                                {% if i['rr'].inttype.name and not i['rr'].force_auto_dml %}
                                                    <a href="{{ url_for('dnsvs.edit_rr_data', area=area.name, suffix=area.suffix, inttype=i['rr'].inttype.name, rr_data=i['rr'].rr_data, fqdn=i['NTree'].fqdn) }}"
                                                       class="btn btn-outline-primary"><i
                                                            class="fa fa-pencil"></i></a>
                                                    <form method="POST"
                                                          action="{{ url_for('dnsvs.delete_rr', area=area.name, suffix=area.suffix) }}"
                                                          class="inline">
                                                        {{ i['del_form'].hidden_tag() }}
                                                        <button type="submit" class="btn btn-outline-danger"><i
                                                                class="fa fa-trash"></i></button>
                                                    </form>
                                                {% endif %}
                                            </td>
                                        </tr>
                                    {% endfor %}
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </section>
                </div>
            {% endfor %}
        </div>
        <div class="col-md-2 d-print-none" role="complementary">
            <ul data-spy="affix" data-offset-top="0" id="area-nav"
                 class="area-sidebar hidden-print hidden-sm hidden-xs nav flex-column">
                    <li class="nav-item"><a class="nav-link" href="#overview">Bereichsinfo</a></li>
                    <li class="nav-item"><a class="nav-link" id="spy_rr_click_reserved" data-target="#reserved"
                           href="#secReserved">Reservierte Adressen</a></li>
                    {% for r in rr_types if r.name in possible_rr_names or r.name in rrs %}
                        <li class="nav-item"><a class="nav-link" id="spy_rr_click_{{ r.name }}" data-target="#{{ r.name }}"
                               href="#sec{{ r.name }}">{{ r.name }}</a></li>
                    {% endfor %}
            </ul>
        </div>
    </div>
{% endblock %}
{% block post_script %}
    <script src="/static/js/netsuite.dnsvs.rr-scrollspy.js"></script>
    <script src="/static/js/netsuite.dnsvs.rr-list.js"></script>
{% endblock %}
